### Method

# Fwupd Client build_report_devices

since: 1.9.20

#### Declaration [src]

    gchar*
    fwupd_client_build_report_devices (
      FwupdClient* self,
      GPtrArray* devices,
      GHashTable* metadata,
      GError** error
    )

#### Description [src]

Builds a JSON report for the list of devices.

This function should be called before asking the interactive user if they want to upload a report — as this function filters devices and may return an error if there is nothing to do.

You must have called `fwupd_client_connect_async()` on `self` before using this method.

Available since: 1.9.20

#### Parameters

`devices`

  Type: An array of `None`

  Devices.

  The data is owned by the caller of the method.

`metadata`

  Type: `GHashTable`

  Attributes.

  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gchar*`

A string, or `NULL` if the ID is not present.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The value is a NUL terminated UTF-8 string.